/*
 *  auth_paula: authenticate SAMBA against XAD/DCOM PAULA
 *  Copyright (C) 2001-2004 PADL Software Pty Ltd. All rights reserved.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 */

#ifndef _RPC_PAULA_H
#define _RPC_PAULA_H

#define PAULA_LM_LOGON_REQUEST			0x00
#define PAULA_LM_CHALLENGE_RESPONSE_REQUEST	0x01
#define PAULA_NT_LOGON_REQUEST			0x02

typedef struct {
	uint32 cookie;
	STRING2 domain;
	STRING2 workstation;
	STRING2 username;
	uchar challenge[8];
	uchar lm_response[24];
	uint32 nt_response_len;
	uchar *nt_response; /* conformant so there should be no pointer? */
} PAULA_Q_NT_LOGON_REQUEST;

typedef struct {
	uint32 cookie;
	uint32 status;
	uint32 sub_status;
	uint32 result;
	uchar user_session_key[16];
	uchar lm_session_key[8];
} PAULA_R_NT_LOGON_REQUEST;

#define TRANS_SYNT_V2                       \
{                                           \
        {                                   \
                0x8a885d04, 0x1ceb, 0x11c9, \
                { 0x9f, 0xe8 },             \
                { 0x08, 0x00,               \
                0x2b, 0x10, 0x48, 0x60 }    \
        }, 0x02                             \
}

#define SYNT_PAULA_V1                       \
{                                           \
        {                                   \
                0x8f529820, 0x168e, 0x11d1, \
                { 0xb7, 0x8e },             \
                { 0x00, 0xa0,               \
                0x24, 0x2a, 0x78, 0xd8 }    \
        }, 0x01                             \
}

#endif /* _RPC_PAULA_H */

