/*
 * Copyright (c) 2001-2004 PADL Software Pty Ltd.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of PADL Software nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY PADL SOFTWARE AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL PADL SOFTWARE OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef _PASSFILT_H_
#define _PASSFILT_H_

#include <sys/types.h>

#ifndef IWinTypes_v0_1_included
typedef u_int16_t USHORT, WCHAR;
typedef u_int32_t ULONG;
typedef u_int8_t BOOLEAN;

typedef ULONG NTSTATUS;

typedef struct {
	USHORT Length;
	USHORT MaximumLength;
	WCHAR *Buffer;
} UNICODE_STRING, *PUNICODE_STRING;
#endif

#ifndef TRUE
#define TRUE	(1)
#endif

#ifndef FALSE
#define FALSE	(0)
#endif

#ifndef NT_STATUS_OK
#define NT_STATUS_OK			0x00000000
#endif

#ifndef NT_STATUS_ILL_FORMED_PASSWORD
#define NT_STATUS_ILL_FORMED_PASSWORD	0xC000006B
#endif

#ifndef NT_STATUS_PWD_TOO_SHORT
#define NT_STATUS_PWD_TOO_SHORT		0xC000025A
#endif

NTSTATUS PasswordChangeNotify(UNICODE_STRING *AccountName,
	ULONG RelativeId,
	UNICODE_STRING *NewPassword);

NTSTATUS PasswordFilter(UNICODE_STRING *AccountName,
	UNICODE_STRING *DisplayName,
	UNICODE_STRING *Password,
	BOOLEAN SetOperation);

/* Not called automatically (yet). */
BOOLEAN InitializeChangeNotify(void) __attribute__ ((constructor));

#endif /* _PASSFILT_H_ */

